package graph;

import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;

import org.jgrapht.Graph;

public class Conflicts<V, E>
{

	private final Graph<V, E> graph;

	HashMap<V, ConflictSet<V>> map = new HashMap<V, ConflictSet<V>>();

	// PriorityQueue<ConflictSet<V>> queue = new PriorityQueue<ConflictSet<V>>();
	public Conflicts(Graph<V, E> graph)
	{
		this(graph, Integer.MAX_VALUE);
	}

	public Conflicts(Graph<V, E> graph, int maxNoConflicts)
	{
		// // maxNoConflicts = Integer.MAX_VALUE;
		//
		// int noConflicts = 0;
		//
		// Store<V, Set<V>> twoClub = GraphAnalysis.getMaxDegreeTwoClub(graph);
		//
		// HashSet<V> potentailConflictVertices = new HashSet<V>(graph.vertexSet());
		// // potentailConflictVertices.removeAll(twoClub.getS2());
		// // twoClub.getS2().remove(twoClub.getS1());
		//
		// for (final V v1 : potentailConflictVertices)
		// {
		// Set<V> n1 = GraphAnalysis.neigbors(graph, v1);
		// n1.add(v1);
		// boolean first = true;
		// Iterator<V> iter = potentailConflictVertices.iterator();
		// boolean switchToN1 = true;
		// while (iter.hasNext())
		// {
		// V v2 = iter.next();
		// if ( v1 != v2 )
		// {
		//
		// Set<V> n2 = GraphAnalysis.neigbors(graph, v2);
		// n2.add(v2);
		// if ( !GraphAnalysis.haveNonEmptyIntersection(n1, n2) )
		// {
		// this.addConflict(v1, v2);
		// noConflicts += first ? 1 : 0;
		// first = false;
		// }
		// }
		// // if ( !iter.hasNext() && switchToN1 )
		// // {
		// // switchToN1 = false;
		// // iter = twoClub.getS2().iterator();
		// // }
		// }
		// if ( noConflicts > maxNoConflicts )
		// break;
		// }

		this.graph = graph;
	}

	public void addConflict(V v1, V v2)
	{
		if ( !this.map.containsKey(v1) )
		{
			final ConflictSet<V> conflictSetV1 = new ConflictSet<V>(v1, null);
			this.map.put(v1, conflictSetV1);
		}
		this.map.get(v1).add(v2);

		if ( !this.map.containsKey(v2) )
		{
			final ConflictSet<V> conflictSetV2 = new ConflictSet<V>(v2, null);
			this.map.put(v2, conflictSetV2);
		}
		this.map.get(v2).add(v1);
	}

	public void addConflictBetweenVertexAndSet(ConflictSet<V> set)
	{
		for (final V v1 : set)
		{
			this.addConflict(set.getV(), v1);
		}
	}

	public ConflictSet<V> getLeastConflict()
	{
		if ( this.map.values() != null && this.map.values().size() > 0 )
			return Collections.max(this.map.values());
		else
			return GraphAnalysis.getVertexPairToFarApart(this.graph);
	}

	public void removeConflict(V v1, V v2)
	{
		if ( this.map.containsKey(v1) )
		{
			final ConflictSet<V> conflictSet = this.map.get(v1);
			conflictSet.remove(v2);
			if ( conflictSet.size() == 0 )
			{
				this.map.remove(v1);
			}
		}
		if ( this.map.containsKey(v2) )
		{
			final ConflictSet<V> conflictSet = this.map.get(v2);
			conflictSet.remove(v1);
			if ( conflictSet.size() == 0 )
			{
				this.map.remove(v2);
			}
		}
	}

	public void removeConflictBetweenVertexAndSet(V v, Collection<V> coll)
	{
		final Collection<V> collTmp = new LinkedList<V>(coll);
		for (final V v2 : collTmp)
		{
			this.removeConflict(v, v2);
		}
	}

	@Override
	public String toString()
	{
		String str = "";
		for (final ConflictSet<V> s : this.map.values())
		{
			str += s.toString();
		}

		return str;
	}
}
