package solvers;

import java.util.Collection;
import java.util.LinkedList;
import java.util.Set;

import dataStructures.Store;

public class DirtyAddVertex<V> extends Store<V, Set<V>>
{
	LinkedList<Store<V, V>> commonNeighborDecrease = new LinkedList<Store<V, V>>();

	private Set<V> neighbors;

	LinkedList<Store<V, V>> newConflicts = new LinkedList<Store<V, V>>();

	public DirtyAddVertex(V vertex, Set<V> conflicts)
	{
		super(vertex, conflicts);
	}

	public void addCommonNeighDecrease(V n1, V n2)
	{
		this.commonNeighborDecrease.add(new Store<V, V>(n1, n2));
	}

	public void addNewConflict(V n1, V n2)
	{
		this.newConflicts.add(new Store<V, V>(n1, n2));
	}

	public Collection<Store<V, V>> getNeighborDecrease()
	{
		return this.commonNeighborDecrease;
	}

	public Set<V> getNeighors()
	{
		return this.neighbors;
	}

	public Collection<Store<V, V>> getNewConflicts()
	{
		return this.newConflicts;
	}

	public V getVertex()
	{
		return this.getS1();
	}

	public Set<V> getVerticesInConflict()
	{
		return this.getS2();
	}

	public void setNeighbors(Set<V> neigh)
	{
		this.neighbors = neigh;
	}
}
