package solvers.dataReduction;

import java.util.ArrayList;
import java.util.Set;

import solvers.UnsolvableException;

/**
 * Mark the only common neighbor of a required vertex pair as a required vertex.
 * 
 * @author sepphar
 * 
 */
public class CommonNeighborsRequiredVertices<V, E> implements RuleInterface<V, E>
{
	@Override
	public boolean reduce(SimpleRuleProvider<V, E> logger) throws UnsolvableException
	{
		boolean somethingReduced = false;
		if ( logger instanceof AdvancedRuleProvider )
		{
			final AdvancedRuleProvider<V, E> logger2 = (AdvancedRuleProvider<V, E>) logger;
			final ArrayList<V> requiredVertices = new ArrayList<V>(logger2.getRequiredVertices());
			for (int i = 0; i < requiredVertices.size(); i++)
			{
				for (int j = i + 1; j < requiredVertices.size(); j++)
				{
					final V v1 = requiredVertices.get(i);
					final V v2 = requiredVertices.get(j);
					if ( logger2.getNoCommonNeighbors(v1, v2) == 1 && !logger2.containsEdge(v1, v2) )
					{
						final Set<V> commonNeighbors = logger2.getCommonNeighbors(v1, v2);
						final V next = commonNeighbors.iterator().next();
						if ( !logger2.getRequiredVertices().contains(next) )
						{
							logger2.setVertexRequired(next);
							somethingReduced = true;
						}
					}
				}
			}
		}
		return somethingReduced;
	}
}
