package solvers.dataReduction;

import java.util.Vector;

import solvers.UnsolvableException;

public class RemoveDegreeOneVertices<V, E> implements RuleInterface<V, E>
{

	@Override
	public boolean reduce(SimpleRuleProvider<V, E> provider) throws UnsolvableException
	{
		boolean somethingRemoved = false;
		final Vector<V> verticesToBeRemoved = new Vector<V>();

		for (final V v : provider.vertexSet())
		{
			if ( provider.getDegreeOf(v) == 1 )
			{
				verticesToBeRemoved.add(v);
				somethingRemoved = true;
			}
		}
		for (final V v : verticesToBeRemoved)
		{
			provider.removeVertex(v);
		}
		return somethingRemoved;
	}

}
